.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\masm32.inc
include  \masm32\include\gdi32.inc 
include	 \masm32\include\winmm.inc ;<- Nedded To Play Music

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\masm32.lib
includelib  \masm32\lib\gdi32.lib 
includelib \masm32\lib\winmm.lib ;<- Nedded To Play Music

include 		lib\ufmod.inc ;<- Nedded To Play Music
includelib 		lib\ufmod.lib ;<- Nedded To Play Music
; ------------------------------------------------------------------------------
; Prototype 
; ------------------------------------------------------------------------------
DialogProc  PROTO : HWND, : UINT, : WPARAM, : LPARAM , : DWORD

.const
; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  	   equ 101
IDI_ICON       equ 200

PictureW        equ 240; picture width in pixels
PictureH        equ 300; picture height in pixels
ID_TIMER    equ 400
SPEED	    equ 5

.data
himage      dd offset himages

.data?
hInstance HINSTANCE ?
hIcon     HICON     ?
himages     db 71*71 dup(?)
flag        db ?


.code

include rgn.inc

start:

invoke GetModuleHandle, NULL 
mov hInstance,eax 
invoke DialogBoxParam,hInstance,IDD_DLG1,NULL,addr DialogProc,NULL 
invoke ExitProcess,eax 
    
; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM ,hImage:DWORD	


LOCAL ps:PAINTSTRUCT
LOCAL hdc:DWORD
LOCAL hMemDC:DWORD
LOCAL rect:RECT
LOCAL myDC:HDC

	.If uMsg == WM_INITDIALOG
  invoke uFMOD_PlaySong,400,hInstance,XM_RESOURCE ;<- Nedded To Play Music	
   invoke GetWindowLong,hWnd,GWL_EXSTYLE 
	invoke SetWindowLong,hWnd,GWL_EXSTYLE,eax 
	invoke SetWindowPos,hWnd,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE+SWP_NOSIZE
mov esi,1
mov edi,offset himages
@@:
invoke LoadImage,hInstance,esi,IMAGE_BITMAP,0,0,
LR_LOADTRANSPARENT or LR_LOADMAP3DCOLORS

mov [edi], eax
add esi,1
cmp esi,72
je @F
add edi,71
jmp @B  
@@: 

invoke  SetWindowPos,hWnd,DS_CENTER,ebx,eax,\
PictureW,PictureH,SWP_SHOWWINDOW

invoke SetTimer,hWnd,ID_TIMER,SPEED,0

.elseif uMsg == WM_COMMAND

.elseIf uMsg == WM_LBUTTONDOWN
invoke SendMessage, hWnd, WM_NCLBUTTONDOWN,HTCAPTION, 0
;The WM_NCLBUTTONDOWN message is posted when the user presses the left mouse button while the cursor is within the 
;nonclient area of a window. This message is posted to the window that contains the cursor. If a window has captured the 
;mouse, this message is not posted. 

.elseif  uMsg == WM_CLOSE || uMsg == WM_RBUTTONUP
invoke EndDialog, hWnd, 0


; WM_ERASEBKGND is needed to Suppress the split second background erase at the start of window [Thanks jj2007]

.elseif  uMsg == WM_ERASEBKGND
xor eax, eax
inc eax
ret    
  
.elseif uMsg == WM_NOTIFY  
Paint_Animate:
.elseif uMsg ==WM_PAINT

    invoke GetWindowRect,hWnd,addr rect
	invoke BeginPaint,hWnd,addr ps
	invoke GetDC,hWnd
    mov hdc,eax
    invoke CreateCompatibleDC,hdc
 	mov hMemDC,eax
    invoke SelectObject,hMemDC,hImage
    invoke GetWindowRect,hWnd,addr rect
    invoke GetClientRect,hWnd,addr rect
    mov eax,hMemDC
 	mov myDC,eax
	push rect.bottom
	push rect.right
	push hMemDC 
	call MakeRegion
	invoke SetWindowRgn,hWnd,eax,TRUE
	invoke BitBlt,hdc,0,0,rect.right,rect.bottom,hMemDC,0,0,SRCCOPY
	invoke DeleteDC,hMemDC
	invoke ReleaseDC,hWnd,hdc
	invoke EndPaint,hWnd,addr ps	


.elseif uMsg == WM_TIMER

inc flag
cmp flag,72
jne @F
mov flag,0
mov himage,offset himages
 
@@:
mov esi,himage
lodsd
push Paint_Animate

add himage,71

.elseif uMsg ==WM_DESTROY || uMsg == WM_RBUTTONUP
invoke KillTimer,hWnd,ID_TIMER
invoke DeleteObject,himage 
invoke PostQuitMessage,NULL   

.endif  
xor eax,eax
ret
DialogProc endp
end start